<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcCharacteristics Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcCharacteristics Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcCharacteristics" --><!-- doxytag: inherits="iBase" -->
<p>This is a characteristics property class.  
 <a href="structiPcCharacteristics.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="chars_8h_source.html">propclass/chars.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcCharacteristics:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcCharacteristics.png" usemap="#iPcCharacteristics_map" alt=""/>
  <map id="iPcCharacteristics_map" name="iPcCharacteristics_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,115,24"/>
</map>
 </div></div>

<p><a href="structiPcCharacteristics-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#adbb4ac7d5e7e499b178bbeb15a0fc7d2">AddToInventory</a> (<a class="el" href="structiPcInventory.html">iPcInventory</a> *inv)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate that this object is added to some inventory.  <a href="#adbb4ac7d5e7e499b178bbeb15a0fc7d2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a53006b5aaa554e853e9ff0ea9f9ce640">ClearAll</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear all properties.  <a href="#a53006b5aaa554e853e9ff0ea9f9ce640"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#ab85e27b1f0b6554c40bf770ecf4a28bd">ClearCharacteristic</a> (const char *name)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clear a characteristic.  <a href="#ab85e27b1f0b6554c40bf770ecf4a28bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a0390526c397dc2f10e4126691be190fe">Dump</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Debug dump information.  <a href="#a0390526c397dc2f10e4126691be190fe"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#ad91240c21b9d25a9365473b8d7e0069e">GetCharacteristic</a> (const char *name) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get characteristic property.  <a href="#ad91240c21b9d25a9365473b8d7e0069e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a50b4613263551a1c55e973b2bf21e0ef">GetInheritedCharacteristic</a> (const char *name) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get inherited characteristic property.  <a href="#a50b4613263551a1c55e973b2bf21e0ef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a83dd879142eecfcaa3d522bb952c0113">GetLocalCharacteristic</a> (const char *name) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get local characteristic property.  <a href="#a83dd879142eecfcaa3d522bb952c0113"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a2425c8b884cf88c1abd6d5bf0117edf3">HasCharacteristic</a> (const char *name) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if a property is present.  <a href="#a2425c8b884cf88c1abd6d5bf0117edf3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#ab3f59dfb199da56e5dd35e270db4163f">MarkDirty</a> (const char *charName)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Mark this characteristic as dirty for all inventories this entity is in.  <a href="#ab3f59dfb199da56e5dd35e270db4163f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#ad745ee9eac4b591f28dac7c94766a70b">RemoveFromInventory</a> (<a class="el" href="structiPcInventory.html">iPcInventory</a> *inv)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate that this object is removed from some inventory.  <a href="#ad745ee9eac4b591f28dac7c94766a70b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#ab63c5cac2b5827697d035094f1a0fad4">SetCharacteristic</a> (const char *name, float value)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set characteristic property.  <a href="#ab63c5cac2b5827697d035094f1a0fad4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a1d74aaead2db36f17b299506d9f76468">SetInheritedCharacteristic</a> (const char *name, float factor, float add)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate how this characteristic is inherited if this object contains an inventory.  <a href="#a1d74aaead2db36f17b299506d9f76468"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcCharacteristics.html#a0e6901afadb5fbf71df6f184a95b8883">TestConstraints</a> (const char *charName)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Test constraints for this characteristic for all inventories this entity is in.  <a href="#a0e6901afadb5fbf71df6f184a95b8883"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a characteristics property class. </p>
<p>This property class supports the following actions (add prefix 'cel.characteristics.action.' if you want to access this action through a message):</p>
<ul>
<li>HasCharacteristic: parameters 'name' (string), returns true/false.</li>
</ul>
<p>This property class supports the following properties:</p>
<ul>
<li>&lt;name&gt; (float, read/write): the specific characteristic. </li>
</ul>

<p>Definition at line <a class="el" href="chars_8h_source.html#l00039">39</a> of file <a class="el" href="chars_8h_source.html">chars.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="adbb4ac7d5e7e499b178bbeb15a0fc7d2"></a><!-- doxytag: member="iPcCharacteristics::AddToInventory" ref="adbb4ac7d5e7e499b178bbeb15a0fc7d2" args="(iPcInventory *inv)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcCharacteristics.html#adbb4ac7d5e7e499b178bbeb15a0fc7d2">iPcCharacteristics::AddToInventory</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcInventory.html">iPcInventory</a> *&#160;</td>
          <td class="paramname"><em>inv</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Indicate that this object is added to some inventory. </p>
<p>This method is meant to be called ONLY by <a class="el" href="structiPcInventory.html" title="This is an inventory property class.">iPcInventory</a> implementations! </p>

</div>
</div>
<a class="anchor" id="a53006b5aaa554e853e9ff0ea9f9ce640"></a><!-- doxytag: member="iPcCharacteristics::ClearAll" ref="a53006b5aaa554e853e9ff0ea9f9ce640" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcCharacteristics.html#a53006b5aaa554e853e9ff0ea9f9ce640">iPcCharacteristics::ClearAll</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clear all properties. </p>
<p>This function can fail if clearing a property causes a violation of parent inventories. In that case part of the properties may be cleared already. </p>

</div>
</div>
<a class="anchor" id="ab85e27b1f0b6554c40bf770ecf4a28bd"></a><!-- doxytag: member="iPcCharacteristics::ClearCharacteristic" ref="ab85e27b1f0b6554c40bf770ecf4a28bd" args="(const char *name)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcCharacteristics.html#ab85e27b1f0b6554c40bf770ecf4a28bd">iPcCharacteristics::ClearCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clear a characteristic. </p>
<p>This can fail if the object is currently in an inventory which requires strict presence of this characteristic. </p>

</div>
</div>
<a class="anchor" id="a0390526c397dc2f10e4126691be190fe"></a><!-- doxytag: member="iPcCharacteristics::Dump" ref="a0390526c397dc2f10e4126691be190fe" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcCharacteristics.html#a0390526c397dc2f10e4126691be190fe">iPcCharacteristics::Dump</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Debug dump information. </p>

</div>
</div>
<a class="anchor" id="ad91240c21b9d25a9365473b8d7e0069e"></a><!-- doxytag: member="iPcCharacteristics::GetCharacteristic" ref="ad91240c21b9d25a9365473b8d7e0069e" args="(const char *name) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcCharacteristics.html#ad91240c21b9d25a9365473b8d7e0069e">iPcCharacteristics::GetCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get characteristic property. </p>
<p>This includes inherited characteristics. </p>

</div>
</div>
<a class="anchor" id="a50b4613263551a1c55e973b2bf21e0ef"></a><!-- doxytag: member="iPcCharacteristics::GetInheritedCharacteristic" ref="a50b4613263551a1c55e973b2bf21e0ef" args="(const char *name) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcCharacteristics.html#a50b4613263551a1c55e973b2bf21e0ef">iPcCharacteristics::GetInheritedCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get inherited characteristic property. </p>
<p>This ignores local characteristic value. </p>

</div>
</div>
<a class="anchor" id="a83dd879142eecfcaa3d522bb952c0113"></a><!-- doxytag: member="iPcCharacteristics::GetLocalCharacteristic" ref="a83dd879142eecfcaa3d522bb952c0113" args="(const char *name) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual float <a class="el" href="structiPcCharacteristics.html#a83dd879142eecfcaa3d522bb952c0113">iPcCharacteristics::GetLocalCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get local characteristic property. </p>
<p>This ignores inherited characteristics. </p>

</div>
</div>
<a class="anchor" id="a2425c8b884cf88c1abd6d5bf0117edf3"></a><!-- doxytag: member="iPcCharacteristics::HasCharacteristic" ref="a2425c8b884cf88c1abd6d5bf0117edf3" args="(const char *name) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcCharacteristics.html#a2425c8b884cf88c1abd6d5bf0117edf3">iPcCharacteristics::HasCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns true if a property is present. </p>

</div>
</div>
<a class="anchor" id="ab3f59dfb199da56e5dd35e270db4163f"></a><!-- doxytag: member="iPcCharacteristics::MarkDirty" ref="ab3f59dfb199da56e5dd35e270db4163f" args="(const char *charName)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcCharacteristics.html#ab3f59dfb199da56e5dd35e270db4163f">iPcCharacteristics::MarkDirty</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>charName</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Mark this characteristic as dirty for all inventories this entity is in. </p>
<p>If 'charName' == 0 then all characteristics will be marked dirty. </p>

</div>
</div>
<a class="anchor" id="ad745ee9eac4b591f28dac7c94766a70b"></a><!-- doxytag: member="iPcCharacteristics::RemoveFromInventory" ref="ad745ee9eac4b591f28dac7c94766a70b" args="(iPcInventory *inv)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcCharacteristics.html#ad745ee9eac4b591f28dac7c94766a70b">iPcCharacteristics::RemoveFromInventory</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcInventory.html">iPcInventory</a> *&#160;</td>
          <td class="paramname"><em>inv</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Indicate that this object is removed from some inventory. </p>
<p>This method is meant to be called ONLY by <a class="el" href="structiPcInventory.html" title="This is an inventory property class.">iPcInventory</a> implementations! </p>

</div>
</div>
<a class="anchor" id="ab63c5cac2b5827697d035094f1a0fad4"></a><!-- doxytag: member="iPcCharacteristics::SetCharacteristic" ref="ab63c5cac2b5827697d035094f1a0fad4" args="(const char *name, float value)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcCharacteristics.html#ab63c5cac2b5827697d035094f1a0fad4">iPcCharacteristics::SetCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set characteristic property. </p>
<p>Returns false if this is impossible because the entity is currently in an inventory that does not allow this value. </p>

</div>
</div>
<a class="anchor" id="a1d74aaead2db36f17b299506d9f76468"></a><!-- doxytag: member="iPcCharacteristics::SetInheritedCharacteristic" ref="a1d74aaead2db36f17b299506d9f76468" args="(const char *name, float factor, float add)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcCharacteristics.html#a1d74aaead2db36f17b299506d9f76468">iPcCharacteristics::SetInheritedCharacteristic</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>factor</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>add</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Indicate how this characteristic is inherited if this object contains an inventory. </p>
<p>The default is to ignore contents of inventory for a characteristic ('factor' and 'add' equal to 0). The value of this characteristic of the inventory will be multiplied with 'factor' and added to 'add'.</p>
<p>This function can fail if the new properties cause the current contents to fail. </p>

</div>
</div>
<a class="anchor" id="a0e6901afadb5fbf71df6f184a95b8883"></a><!-- doxytag: member="iPcCharacteristics::TestConstraints" ref="a0e6901afadb5fbf71df6f184a95b8883" args="(const char *charName)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcCharacteristics.html#a0e6901afadb5fbf71df6f184a95b8883">iPcCharacteristics::TestConstraints</a> </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>charName</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Test constraints for this characteristic for all inventories this entity is in. </p>
<p>If 'charName' == 0 then all characteristics will be tested. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="chars_8h_source.html">chars.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
